<template>
	<div class="app-container">
		<el-row :gutter="10" class="mb8">
			<el-col :span="1.5">
				<el-button
					type="primary"
					plain
					icon="el-icon-plus"
					size="mini"
					@click="handleAdd"
					v-hasPermi="['mes:reportWorkConsume:add']"
				>新增</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="success"
					plain
					icon="el-icon-edit"
					size="mini"
					:disabled="single"
					@click="handleUpdate"
					v-hasPermi="['mes:reportWorkConsume:edit']"
				>修改</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="danger"
					plain
					icon="el-icon-delete"
					size="mini"
					:disabled="multiple"
					@click="handleDelete"
					v-hasPermi="['mes:reportWorkConsume:remove']"
				>删除</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="warning"
					plain
					icon="el-icon-download"
					size="mini"
					@click="handleExport"
					v-hasPermi="['mes:reportWorkConsume:export']"
				>导出</el-button>
			</el-col>
			<right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
		</el-row>

		<el-table v-loading="loading" :data="reportWorkConsumeList" @selection-change="handleSelectionChange">
			<el-table-column type="selection" width="55" align="center" />
			<el-table-column label="id" align="center" prop="recordId" />
			<el-table-column label="工单编码" align="center" prop="workorderCode" width="200"/>
			<el-table-column label="物料编号" align="center" prop="materialCode" width="200"/>
			<el-table-column label="物料名称" align="center" prop="materialName" width="200"/>
			<el-table-column label="物料规格型号" align="center" prop="materialSpc" width="200"/>
			<el-table-column label="数量" align="center" prop="quantity" />
			<el-table-column label="单位" align="center" prop="unit" />
			<el-table-column label="备注" align="center" prop="remark" />
			<el-table-column label="工厂编码" align="center" prop="factoryCode" />
			<el-table-column label="操作" v-if="optType !='view'" align="center" class-name="small-padding fixed-width">
				<template slot-scope="scope">
					<el-button
						size="mini"
						type="text"
						icon="el-icon-edit"
						@click="handleUpdate(scope.row)"
						v-hasPermi="['mes:reportWorkConsume:edit']"
					>修改</el-button>
					<el-button
						size="mini"
						type="text"
						icon="el-icon-delete"
						@click="handleDelete(scope.row)"
						v-hasPermi="['mes:reportWorkConsume:remove']"
					>删除</el-button>
				</template>
			</el-table-column>
		</el-table>

		<pagination
			v-show="total>0"
			:total="total"
			:page.sync="queryParams.pageNum"
			:limit.sync="queryParams.pageSize"
			@pagination="getList"
		/>

		<!-- 添加或修改生产报工物料消耗对话框 -->
		<el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
			<el-form ref="form" :model="form" :rules="rules" label-width="80px">
				<el-form-item label="工单编码" prop="workorderCode">
					<el-input v-model="form.workorderCode" placeholder="请输入工单编码" />
				</el-form-item>
				<el-form-item label="物料编号" prop="materialCode">
					<el-input v-model="form.materialCode" placeholder="请输入物料编号" />
				</el-form-item>
				<el-form-item label="物料名称" prop="materialName">
					<el-input v-model="form.materialName" placeholder="请输入物料名称" />
				</el-form-item>
				<el-form-item label="物料规格型号" prop="materialSpc">
					<el-input v-model="form.materialSpc" placeholder="请输入物料规格型号" />
				</el-form-item>
				<el-form-item label="数量" prop="quantity">
					<el-input v-model="form.quantity" placeholder="请输入数量" />
				</el-form-item>
				<el-form-item label="单位" prop="unit">
					<el-input v-model="form.unit" placeholder="请输入单位" />
				</el-form-item>
				<el-form-item label="备注" prop="remark">
					<el-input v-model="form.remark" placeholder="请输入备注" />
				</el-form-item>
				<el-form-item label="工厂编码" prop="factoryCode">
					<el-input v-model="form.factoryCode" placeholder="请输入工厂编码" />
				</el-form-item>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button type="primary" @click="submitForm">确 定</el-button>
				<el-button @click="cancel">取 消</el-button>
			</div>
		</el-dialog>
	</div>
</template>

<script>
import { listReportWorkConsume, getReportWorkConsume, delReportWorkConsume, addReportWorkConsume, updateReportWorkConsume } from "@/api/mes/reportWorkConsume";

export default {
	name: "ReportWorkConsume",
	data() {
		return {
			// 遮罩层
			loading: true,
			// 选中数组
			ids: [],
			// 非单个禁用
			single: true,
			// 非多个禁用
			multiple: true,
			// 显示搜索条件
			showSearch: true,
			// 总条数
			total: 0,
			// 生产报工物料消耗表格数据
			reportWorkConsumeList: [],
			// 弹出层标题
			title: "",
			// 是否显示弹出层
			open: false,
			// 查询参数
			queryParams: {
				pageNum: 1,
				pageSize: 10,
				workorderCode: null,
				materialCode: null,
				materialName: null,
				materialSpc: null,
				quantity: null,
				unit: null,
				attr1: null,
				attr2: null,
				attr3: null,
				attr4: null,
				factoryCode: null,
				reportCode :this.reportCode
			},
			// 表单参数
			form: {},
			// 表单校验
			rules: {
				workorderCode: [
					{ required: true, message: "工单编码不能为空", trigger: "blur" }
				],
				materialCode: [
					{ required: true, message: "物料编号不能为空", trigger: "blur" }
				],
				materialName: [
					{ required: true, message: "物料名称不能为空", trigger: "blur" }
				],
				unit: [
					{ required: true, message: "单位不能为空", trigger: "blur" }
				],
			}
		};
	},
	props: {
      reportCode: null,
      optType: undefined,
    },
	created() {
		this.getList();
	},
	methods: {
		/** 查询生产报工物料消耗列表 */
		getList() {
			this.loading = true;
			listReportWorkConsume(this.queryParams).then(response => {
			  console.log('报工编号',this.queryParams.reportCode);
				this.reportWorkConsumeList = response.rows;
				this.total = response.total;
				this.loading = false;
			});
		},

		// 取消按钮
		cancel() {
			this.open = false;
			this.reset();
		},
		// 表单重置
		reset() {
			this.form = {
				recordId: null,
				workorderCode: null,
				materialCode: null,
				materialName: null,
				materialSpc: null,
				quantity: null,
				unit: null,
				remark: null,
				attr1: null,
				attr2: null,
				attr3: null,
				attr4: null,
				createBy: null,
				createTime: null,
				updateBy: null,
				updateTime: null,
				factoryCode: null,
				reportCode: this.reportCode
			};
			this.resetForm("form");
		},
		/** 搜索按钮操作 */
		handleQuery() {
			this.queryParams.pageNum = 1;
			this.getList();
		},
		/** 重置按钮操作 */
		resetQuery() {
			this.resetForm("queryForm");
			this.handleQuery();
		},
		// 多选框选中数据
		handleSelectionChange(selection) {
			this.ids = selection.map(item => item.recordId)
			this.single = selection.length!==1
			this.multiple = !selection.length
		},
		/** 新增按钮操作 */
		handleAdd() {
			this.reset();
			this.open = true;
			this.title = "添加生产报工物料消耗";
		},
		/** 修改按钮操作 */
		handleUpdate(row) {
			this.reset();
			const recordId = row.recordId || this.ids
			getReportWorkConsume(recordId).then(response => {
				this.form = response.data;
				this.open = true;
				this.title = "修改生产报工物料消耗";
			});
		},
		/** 提交按钮 */
		submitForm() {
			this.$refs["form"].validate(valid => {
				if (valid) {
					if (this.form.recordId != null) {
						updateReportWorkConsume(this.form).then(response => {
							this.$modal.msgSuccess("修改成功");
							this.open = false;
							this.getList();
						});
					} else {
						addReportWorkConsume(this.form).then(response => {
							this.$modal.msgSuccess("新增成功");
							this.open = false;
							this.getList();
						});
					}
				}
			});
		},
		/** 删除按钮操作 */
		handleDelete(row) {
			const recordIds = row.recordId || this.ids;
			this.$modal.confirm('是否确认删除生产报工物料消耗编号为"' + recordIds + '"的数据项？').then(function() {
				return delReportWorkConsume(recordIds);
			}).then(() => {
				this.getList();
				this.$modal.msgSuccess("删除成功");
			}).catch(() => {});
		},
		/** 导出按钮操作 */
		handleExport() {
			this.download('mes/reportWorkConsume/export', {
				...this.queryParams
			}, `reportWorkConsume_${new Date().getTime()}.xlsx`)
		}
	}
};
</script>
